// Funktion : Geburtstagstester ( Vor- u. Nachausgabe von Geburtstagen )
// Sprache  : Borland C++ 5.02
// Autor    : Manfred Ebert

#include <classlib/date.h>
#include <owl/listbox.h>
#include <owl/dialog.h>
#include <owl/edit.h>
#include <owl/static.h>
#include <owl/button.h>
#include <owl/opensave.h>
#include <owl/statusba.h>
#include <owl/pch.h>
#include <owl/dc.h>
#include <owl/applicat.h>
#include <owl/framewin.h>
#include <fstream.h>
#include <string.h>
#include <dos.h>
#include <stdio.h>
#include <dir.h>
#include "winbirth.h"

const int MaxEdit 	= 30;
const int MaxChar	   = 255;
const int Rand			= 10;
const int xAbstand 	= 200;
const int yAbstand	= 120;
const int xNull		= 10;		// Gre und Position der Anwendung;
const int yNull		= 10;
const int xClient 	= 620;	// Arbeitsflche
const int yClient 	= 380;
const int wMax			= xClient + 8;	// Fenstermasse + Rand
const int hMax			= yClient + 65;
const int MaxDateien	= 10;
const int h				= 16;		// Textfeldhhe

const	char * szProgName       = "Geburtstagstester WinBirth V 1.00 d";
const char * St_Bild	      	= "monza-1.bmp";
const char * St_InfoFile 		= "test.dat";
const char * St_TagInfo    	= "Tag-Info.dat";
const char * Ueb_Winbirth	= "[WINBIRTH]";
const char * Ueb_Tage		= "[TAGE]";
const char * Ueb_Dateien	= "[DATEIEN]";
const char * Ueb_TagInfo	= "[TAGINFO]";
const char * Ueb_Bmp			= "[BMP]";
const char * Ueb_ENDE      = "[ENDE]";
const char * IniFile    = "winbirth.cfg";
const char *szLeer		= "Leer";
const char *szTXT_Tage  = " Tage";
const char *szPunkt   	= ".";
const char *szNull		= "0";
const char *szSpace		= " ";
const char *cLF      	= "\r\n";

// Die Monate mit max. Tagen und Schaltjahr
int TageMonat[] =  { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
int Abstand_Tage   = 3;
char* szNameMonat[] =  { "", "Januar", "Februar", "Mrz", "April", "Mai", "Juni",
								 "Juli", "August", "September", "Oktober", "November",
                        "Dezember" };

string Test_Datum_1 		= "";
string Test_Datum_11 	= "";
string Test_Datum_12 	= "";
string Test_Datum_2		= "";
string Heute_Datum  		= "";
string Ausgabe_Info 		= "";
string Ausgabe_Heute		= "";
string InfoTXT				= "";

string Str_Suchen( string Suchen, string InQuelle );
string KopfAusgabe( int nAbstand );

TStatusBar * sb;
TTextGadget *TextTag;

struct TTransferBuffer {
	char szAbstand_Tage[MaxEdit];
   TListBoxData ListBoxData;
   char szBild_Datei[MaxChar];
};

struct dosdate_t Date;

class TBirthDia	: public TDialog
{
public:
	TBirthDia( TWindow* parent,int resId ,TTransferBuffer& ts);
   void CloseWindow( int ret );
   void CmEinfuegen();
   void CmEntfernen();
   void CmDurchsuchen();

private:
	TListBox *ListBox;			// Dateien im Verzeichnis
   TEdit *ListBoxData;			// Daten aus dem Transferbuffer
   TEdit *NeueBmp;				// Neue BMP-Datei

   DECLARE_RESPONSE_TABLE( TBirthDia );
};
DEFINE_RESPONSE_TABLE1( TBirthDia, TDialog )
   EV_BN_CLICKED( IDC_BUTTON1, CmEinfuegen ),
   EV_BN_CLICKED( IDC_BUTTON2, CmEntfernen ),
   EV_BN_CLICKED( IDC_BUTTON3, CmDurchsuchen ),
END_RESPONSE_TABLE;

TBirthDia::TBirthDia( TWindow * parent, int resId,TTransferBuffer& ts )
				: TDialog( parent, resId )

{	// Die Reihenfolge im Transferbuffer mu eingehalten werden
   new TEdit( this, IDC_EDIT1, MaxEdit );
   ListBox = new TListBox( this, IDC_LISTBOX1 );
   ListBox -> EnableTransfer();
   NeueBmp = new TEdit( this, IDC_EDIT2, MaxChar );

   SetTransferBuffer(&ts );
}

void TBirthDia::CloseWindow( int ret )
{
	TransferData( tdGetData );
   TDialog::CloseWindow( ret );
}

void TBirthDia::CmEinfuegen( )
{
   TFileOpenDialog::TData Data
   (OFN_HIDEREADONLY|OFN_PATHMUSTEXIST,
   "Dat Dateien (*.dat) | *.dat|Text Dateien (*.txt)|*.txt|Alle Dateien (*.*)|*.*|",
   0, "", "*");

  if (TFileOpenDialog(this, Data).Execute() == IDOK)
  {
    if (Data.Error != 0)
    {
    	MessageBox( "Testdatei kann nicht geladen werden.",
      				"Dateifehler!", MB_OK );
      return;
    }
    	ListBox->AddString( Data.FileName );
  }
}

void TBirthDia::CmEntfernen()
{
  int Index = ListBox ->GetSelIndex();
   int Anzahl = ListBox->GetCount();

   if ( Anzahl <= 1 )
   {
    	MessageBox(  "Es mu mindestens eine Datei vorhanden sein",
                   "Fehler", MB_OK );
      return;
   }
   if ( Index >= 0 )
    ListBox->DeleteString(Index);
}

void TBirthDia::CmDurchsuchen()
{
   TFileOpenDialog::TData Data
   (OFN_HIDEREADONLY|OFN_PATHMUSTEXIST,
   "Bitmap Dateien (*.bmp)| *.bmp" , 0, "", "*");

  if (TFileOpenDialog(this, Data).Execute() == IDOK)
  {
    if (Data.Error != 0)
    {
    	MessageBox( "Bmp - Datei kann nicht geladen werden.",
      				"Dateifehler!", MB_OK );
      return;
    }
    NeueBmp->Clear();
    NeueBmp-> Insert( Data.FileName );
  }
}

class TBirthWin : public TWindow
{
	public:
   	TBirthWin( TWindow* parent = 0 );
      ~TBirthWin();

      int nAnzahl;
      char *Test_Dateien[MAXPATH],		// Namen der Dateien
           *Winbirth_Path,					// Path der Anwendung
           *TagInfoDatei,              // Name der Tag Infodatei
           *Bmp;								// Name des BMP's
      TBitmap *bm;

   protected:
		TEdit *AusgabeFeld,			// Ausgabefeld Vor- und Nachinfo
            *AusgabeHeute,			// Ausgabe Geburtstagskinder
            *Tag_Info;				// Ausgabe v. Tagesinformationen

		TStatic *UeberSchriftGeb,	// berschrift Fenster Geburtstagsausgabe
      		  *UeberSchriftVors;	// berschrift Fenster Vorschau

      void Paint( TDC&, bool, TRect& );
      virtual void SetupWindow();
		void Str_Datum( int Offset );
      void AusgabeText();
      void ShowBmp( TBitmap &bm );
      void CmSetup();
      void Test();
      void CmExit() { SendMessage( WM_CLOSE ); }
      void CmInfo() { MessageBox( szProgName, "Info", MB_OK ); }
      void IniLesen();
      void WR_Ini();
      void StandardIni( char * szFehler);
      void Show_Datum(TDC& dc);
      void TagInfoTXT();
      void Status_Out();
      int TageVonMonat(  int Monat, int Jahr );

	private:
   	TTransferBuffer TransferBuffer;			// Transferbuffer definieren
      TBirthDia* Dia;

   DECLARE_RESPONSE_TABLE( TBirthWin );
};
DEFINE_RESPONSE_TABLE1( TBirthWin, TWindow )
	EV_COMMAND( CM_SETUP, CmSetup ),
	EV_COMMAND( CM_EXIT, CmExit ),
	EV_COMMAND( CM_INFO, CmInfo ),
   EV_BN_CLICKED( IDB_OK, CmExit ),
END_RESPONSE_TABLE;

TBirthWin::TBirthWin( TWindow *parent )
: TWindow( parent )
{
	_dos_getdate( &Date );

	AusgabeFeld = new TEdit( this, ID_MeldeEdit, NULL,
   						   2*xAbstand + Rand , Rand +h , xAbstand  ,
                        3*yAbstand  -h  , 0, TRUE );

   UeberSchriftVors = new TStatic( this, -1, "Vorschau : ", 2*xAbstand + Rand,
   											Rand, xAbstand , h );
   UeberSchriftVors->Attr.Style = (UeberSchriftVors->Attr.Style &~SS_LEFT ) | SS_CENTER;

   AusgabeHeute = new TEdit( this, ID_HeuteEdit, NULL,
   						   Rand , 2*yAbstand+ Rand  + h , 2*xAbstand - Rand,
                        yAbstand - h  , 0, TRUE );

   UeberSchriftGeb = new TStatic( this, -1, "Geburtstagskinder : ", Rand,
   											2*yAbstand + Rand , 2*xAbstand - Rand, h );
   UeberSchriftGeb->Attr.Style = (UeberSchriftGeb->Attr.Style &~SS_LEFT ) | SS_CENTER;

	Tag_Info = new TEdit( this, ID_Tag_Info, NULL, 2*Rand + xAbstand ,
   							 0.8*yAbstand    , xAbstand - 2*Rand,
                        yAbstand -Rand  , 0, TRUE );

	Tag_Info->Attr.Style &= ~WS_VSCROLL;
	Tag_Info->Attr.Style &= ~WS_HSCROLL;
	Tag_Info->Attr.Style &= ~ES_AUTOHSCROLL;
	Tag_Info->Attr.Style &= ~ES_AUTOVSCROLL;

  int wButton	= 640 / 8,
  hButton  = 480 / 20;

  new TButton( this, IDB_OK, "Beenden", 1.5*xAbstand - wButton/2 ,
   			2*yAbstand - hButton  , wButton, hButton );

  IniLesen();

  unsigned attrib;
  if (( _dos_getfileattr( Bmp, &attrib )) != 0 ) bm = NULL;
  else
  { try
  	{ bm = new TBitmap( Bmp ); }
   catch(...)
   {   	MessageBox(  "Bmp - Datei ist nicht kompatibel",
      				"Fehler : Bmp - Datei", MB_OK );
     		bm = NULL;
   }
  }

  TagInfoTXT();
  AusgabeText();
}

TBirthWin::~TBirthWin()
{
	WR_Ini();

   for ( int i = 0; i > nAnzahl; i++ )
   		delete[] Test_Dateien[nAnzahl];

   if ( Bmp != NULL ) delete Bmp;
   delete TagInfoDatei;
   delete Winbirth_Path;
   delete bm;
}

void TBirthWin::Paint( TDC& dc, bool, TRect& )
{
   if ( bm != NULL ) ShowBmp( *bm);
   Show_Datum(dc);
   Status_Out();
}

void TBirthWin::SetupWindow()
{
 	TWindow::SetupWindow();

  	AusgabeFeld ->Insert( Ausgabe_Info.c_str() );
   AusgabeHeute->Insert( Ausgabe_Heute.c_str() );
  	Tag_Info->Insert( InfoTXT.c_str() );
}

void TBirthWin::Str_Datum( int Offset )
{
   char szTag[5],
        szMonat[5];

   int nTag   = Date.day + Offset ;
   int nMonat = Date.month;
   int nJahr  = Date.year;

  // Ein Monat wird zurckgesprungen
   if  ( nTag <= 0 )
   {
      nMonat--;
      // Es wird ein Jahr zurck gesprungen
      if ( nMonat <= 0 )
      {
      	nMonat = 12;
         nJahr -= 1;
      }
        nTag = TageVonMonat( nMonat, nJahr ) + Offset + Date.day ;
    }

   // Ein Monat wird vorgesprungen
   if ( nTag > TageVonMonat( nMonat, nJahr ) )
   {
   	nTag = Date.day - TageVonMonat( nMonat, nJahr ) + Offset;

		nMonat++;

      if ( nMonat > 12 ) nMonat = 1;
  }

   itoa( nTag, szTag, 10 );
   itoa( nMonat, szMonat, 10 );

   // Datumsformate: z.B.
   // -  3.1    Test_Datum_1   : Ohne Nullen
   // - 03.1    Test_Datum_11
   // -  3.01   Test_Datum_12
   // - 03.01   Test_Datum_2

   // Alle Datumstrings zurcksetzen
   Test_Datum_1.remove( 0 );
   Test_Datum_11.remove( 0 );
   Test_Datum_12.remove( 0 );
   Test_Datum_2.remove( 0 );

   // Test_Datum_1 erstellen
   Test_Datum_1.append( szTag );
   Test_Datum_1.append( szPunkt );
   Test_Datum_1.append( szMonat );

   // Test_Datum_11 erstellen
   if ( nTag < 10 )
   {
   	Test_Datum_11.append( szNull );
   	Test_Datum_11.append( szTag );
   	Test_Datum_11.append( szPunkt );
   	Test_Datum_11.append( szMonat );
   }
   else
    Test_Datum_11.append( szLeer );

   // Test_Datum_12 erstellen
   if ( nMonat < 10 )
   {
   	Test_Datum_12.append( szTag );
   	Test_Datum_12.append( szPunkt );
   	Test_Datum_12.append( szNull );
   	Test_Datum_12.append( szMonat );
   }
   else
    Test_Datum_12.append( szLeer );

    // Test_Datum_2 erstellen
   // Datum mit Null bei Tag & Monat, ergnzen
   // Testen, ob das 2.Datum erforderlich ist.
   if ( ( nTag < 10 ) && ( nMonat < 10 ) )
   {
	   Test_Datum_2.append( szNull );
	   Test_Datum_2.append( szTag );
	   Test_Datum_2.append( szPunkt );
	   Test_Datum_2.append( szNull );
	   Test_Datum_2.append( szMonat );
   }
	else
   	Test_Datum_2.append( szLeer );
}

void TBirthWin::AusgabeText()
{
   string InDatei( "" );

   for ( int nCount = 0; nCount < nAnzahl; nCount++ )
  {
   string Read_Datei( "" );

   fstream InDat;
   InDat.open( Test_Dateien[nCount], ios::in | ios::nocreate );

   if( InDat.good() )
   {
   	Read_Datei.read_file( InDat );
   	InDatei.append( Read_Datei );
   }
   else
   	MessageBox(  Test_Dateien[nCount], "Fehler beim ffnen der Testdatei :",
      				 MB_ICONSTOP );
   InDat.close();
  }

   string Ausgabe( "" );
   string KopfUndAusgabe( "" );

  for ( int nCount = Abstand_Tage * (-1) ; nCount <= Abstand_Tage; nCount++ )
  {
    Str_Datum( nCount );

   KopfUndAusgabe.append ( Str_Suchen( Test_Datum_1, InDatei ));

   // Testen,ob Test_Datum_11 vorhanden ist
   int nVergleich = Test_Datum_11.compare( szLeer );
   if ( nVergleich != 0 )
	   KopfUndAusgabe.append ( Str_Suchen( Test_Datum_11, InDatei ));

   // Testen,ob Test_Datum_12 vorhanden ist
   nVergleich = Test_Datum_12.compare( szLeer );
   if ( nVergleich != 0 )
	   KopfUndAusgabe.append ( Str_Suchen( Test_Datum_12, InDatei ));

   // Testen,ob Test_Datum_2 vorhanden ist
   nVergleich = Test_Datum_2.compare( szLeer );
   if ( nVergleich != 0 )
	   KopfUndAusgabe.append ( Str_Suchen( Test_Datum_2, InDatei ));

   if ( KopfUndAusgabe.length() != 0 )
   {
      Ausgabe.append( KopfAusgabe( nCount ) );
   	Ausgabe.append( KopfUndAusgabe );

      // Ausgabe der heutigen Geburtstagskindern
      if (  nCount == 0 )
      	Ausgabe_Heute.append( KopfUndAusgabe );
   }
   KopfUndAusgabe.remove( 0 );
  }
  Ausgabe_Info = Ausgabe;
}

void TBirthWin::ShowBmp( TBitmap &bm )
{
   TClientDC dc(*this);

   TMemoryDC memdc(dc);
   memdc.SelectObject( bm );

   dc.StretchBlt( Rand , Rand , xAbstand , 2*yAbstand-Rand
   			, memdc, 0, 0, bm.Width(),bm.Height(), SRCCOPY );
}

void TBirthWin::IniLesen()
{
   char InCh[MaxChar],
   	  Path[MAXPATH];

   getcwd( Path, MAXPATH );
   Winbirth_Path = new char[ strlen( Path ) + 1 ];
   strcpy(  Winbirth_Path, Path );

	ifstream fin;
	fin.open( IniFile );

   if ( fin.fail() )
   {
      StandardIni( "winbirth.cfg fehlt !" );
      fin.close();
      return;
   }
   // Ueberschrift testen
   fin.getline( InCh, MaxChar );
   if ( strcmp ( Ueb_Winbirth, InCh ) != 0 )
   {
      StandardIni( "berschrift von winbirth.cfg" );
      fin.close();
      return;
   }
   // Text: [TAG] testen
   fin.getline( InCh, MaxChar );
   if ( strcmp ( Ueb_Tage, InCh ) != 0 )
   {
      StandardIni( "Text:[TAG] von winbirth.cfg" );
      fin.close();
      return;
   }
   // Anzahl der Tage einlesen
   fin.getline( InCh, MaxChar );
   Abstand_Tage = atoi( InCh );

   if ( Abstand_Tage >= 365 )
   {
      StandardIni( "Tage in winbirth.cfg grer,als 365" );
      fin.close();
      return;
   }
   // Text: [DATEIEN] testen
   fin.getline( InCh, MaxChar );
   if ( strcmp ( Ueb_Dateien, InCh ) != 0 )
   {
      StandardIni( "Text:[DATEIEN] von winbirth.cfg" );
      fin.close();
      return;
   }
   // Testdateien einlesen
   for ( nAnzahl = 0; nAnzahl < MaxDateien; nAnzahl++ )
   {
		fin.getline( InCh, MaxChar );
      if ( strcmp( Ueb_TagInfo, InCh ) == 0 ) break;

      Test_Dateien[nAnzahl] = new char[ strlen ( InCh ) + 1 ];
      strcpy( Test_Dateien[nAnzahl], InCh );
   }
   // TagInfoDatei lesen
   fin.getline( InCh, MaxChar );

   TagInfoDatei = new char[ strlen( InCh ) + 1 ];
   strcpy( TagInfoDatei, InCh );
   // Text : [BMP] einlesen
  fin.getline( InCh, MaxChar );
   if ( strcmp ( Ueb_Bmp, InCh ) != 0 )
   {
      StandardIni( "Text:[BMP] von winbirth.cfg" );
      fin.close();
      return;
   }
   // Bmp - Name einlesen
   fin.getline( InCh, MaxChar );
   Bmp = new char[ strlen( InCh ) + 1 ];
   strcpy( Bmp, InCh );
   // Text : [ENDE] einlesen
  fin.getline( InCh, MaxChar );
   if ( strcmp ( Ueb_ENDE, InCh ) != 0 )
   {
      StandardIni( "Text:[ENDE] von winbirth.cfg" );
      fin.close();
      return;
   }
	fin.close();
}

void TBirthWin::StandardIni( char * szFehler )
{
      char TXT_Fehler[80] = "Fehler : ";
      strcat( TXT_Fehler, szFehler );

   	MessageBox(  "Standardeinstellungen werden geladen.",
      				TXT_Fehler, MB_OK );
      Abstand_Tage = 10;
           nAnzahl = 1;

      Test_Dateien[0] = new char[strlen( St_InfoFile) +1  ];
      strcpy( Test_Dateien[0],St_InfoFile );

      TagInfoDatei = new char[ strlen( St_TagInfo ) + 1 ];
      strcpy ( TagInfoDatei, St_TagInfo );

      Bmp = new char[ strlen( St_Bild ) + 1 ];
      strcpy ( Bmp, St_Bild );
}

void  TBirthWin::WR_Ini()
{
   char szFile[ MaxChar ];
   strcpy( szFile, Winbirth_Path );
   strcat( szFile, "\\" );
   strcat( szFile, IniFile );

	ofstream fout;
	fout.open( szFile );

   if ( fout.fail() )
   {
   	MessageBox(  "Fehler beim schreiben der Datei.",
      				" Fehler : Winbirth.cfg  ", MB_OK );
      fout.close();
      return ;
   }

    fout << Ueb_Winbirth << "\n"
    		<< Ueb_Tage << "\n"
         << Abstand_Tage << "\n"
         <<  Ueb_Dateien << "\n";

    for ( int i = 0; i < nAnzahl; i++ )
    {
      fout << Test_Dateien[i] << "\n";
    }

    fout << Ueb_TagInfo << "\n"
         << TagInfoDatei << "\n"
         << Ueb_Bmp << "\n"
         << Bmp << "\n"
         << Ueb_ENDE;

    fout.close();
}

void TBirthWin::CmSetup()
{
   // Editfeld fllen
   char szTage[10];
   itoa ( Abstand_Tage, szTage , 10 );
	strcpy ( TransferBuffer.szAbstand_Tage, szTage );

   strcpy ( TransferBuffer.szBild_Datei, Bmp );

   // Listbox fllen
	for ( int i = 0; i < nAnzahl; i++ )
	   TransferBuffer.ListBoxData.AddString( Test_Dateien[i] );

   Dia = new TBirthDia( this, IDD_DIALOG1, TransferBuffer );

   if ( Dia->Execute() == IDOK )
   {
   	   // Daten aus der Struktur lesen und testen
        int Tage =  atoi( TransferBuffer.szAbstand_Tage );

       if (( Tage < 29  ) && ( Tage > 0 ))
       	 Abstand_Tage = Tage;
       else
       {
       	MessageBox(  "Standardzeitraum : 3 Tagen eingestellt",
      				"Fehler: Zeitraumangabe", MB_OK );
       	 Abstand_Tage = 3;
       }
      // Listbox auslesen ( Neue Tesdateinen einlesen )
      TStringArray& lbStrArray =  TransferBuffer.ListBoxData.GetStrings();
      unsigned lbNItems			 =  lbStrArray.GetItemsInContainer();
      nAnzahl = lbNItems;

      if ( lbNItems != 0 )
      {
      	TStringArrayIterator iter( lbStrArray );
         for( int c = 0; c < lbNItems; c++,iter++ )
         {
            string strDateien;
            strDateien += iter.Current();

            Test_Dateien[c] = new char[ strDateien.length() +1  ];
            strcpy ( Test_Dateien[c] , strDateien.c_str() );
         }
       }
     //BMP - Datei laden
     Bmp = new char[ strlen( TransferBuffer.szBild_Datei ) + 1 ];
     strcpy ( Bmp , TransferBuffer.szBild_Datei);

     if ( bm != NULL ) delete bm;
     try
     {
      bm = new TBitmap( Bmp );
     }
     catch(...)
     {
      	MessageBox(  "Bmp - Datei ist nicht kompatibel",
      				"Fehler : Bmp - Datei", MB_OK );
     		bm = NULL;
     }
   }
   TransferBuffer.ListBoxData.Clear();

 Test();
 Invalidate();
}

void TBirthWin::Test()
{
  Ausgabe_Info.remove(0);
  Ausgabe_Heute.remove(0);

  AusgabeText();

  AusgabeFeld ->Clear();
  AusgabeFeld ->Insert( Ausgabe_Info.c_str() );

  AusgabeHeute->Clear();
  AusgabeHeute->Insert( Ausgabe_Heute.c_str() );
}

void TBirthWin::Show_Datum(TDC& dc)
{
   int Hoehe_2 = 40,
       Hoehe   = 20;

  TRect Rect_1(  2*Rand + xAbstand , Rand , 2*xAbstand , Rand + Hoehe  );
  TRect Rect_2(  2*Rand + xAbstand , Rand + Hoehe, 2*xAbstand , Rand + Hoehe + Hoehe_2  );
  TRect Rect_3(  2*Rand + xAbstand ,Rand + Hoehe + Hoehe_2  , 2*xAbstand , Rand + 2*Hoehe + Hoehe_2 );

   dc.SetBkColor( GetSysColor( COLOR_WINDOW ) );
   TFont pFont( "Times Roman" , Hoehe );

   dc.SelectObject( pFont );
   // Ausgabe Jahreszahl
   char szJahr[10];
   itoa( Date.year, szJahr, 10 );
   dc.DrawText( szJahr, strlen( szJahr ), Rect_1, DT_CENTER );
   // Azsgabe Monat
   dc.DrawText( szNameMonat[ Date.month ], strlen( szNameMonat[ Date.month ] ),
                Rect_3, DT_CENTER );
   // TAG AUSGABE
   TFont pFont_2( "Arial", Hoehe_2 );
   int Breite_2 = pFont_2.GetAveWidth(dc);

   dc.SelectObject( pFont_2 );
	dc.SetTextColor ( TColor::LtBlue );

   char szTag[5];
   itoa( Date.day, szTag, 10 );
   dc.DrawText( szTag, strlen( szTag ), Rect_2, DT_CENTER );
   dc.RestoreFont();
}

void TBirthWin::TagInfoTXT()
{
   string Read_Datei( "" );
   ifstream InDat( TagInfoDatei , ios::in | ios::nocreate );

   if ( InDat.fail() )
   {
      char Meldung[80] = "Datei kann nicht geladen werden : ";
      strcat( Meldung, TagInfoDatei );

      MessageBox(  Meldung , "Datei fr Taginfo fehlt.", MB_OK );

      InDat.close();
      return;
   }

   Read_Datei.read_file( InDat );
   InDat.close();
   // Datum ermitteln
   Str_Datum( 0 );
	InfoTXT.append ( Str_Suchen( Test_Datum_1, Read_Datei ));

   int nVergleich = Test_Datum_11.compare( szLeer );
   if ( nVergleich != 0 )
	   InfoTXT.append ( Str_Suchen( Test_Datum_11,Read_Datei ));
   // Testen,ob Test_Datum_12 vorhanden ist
   nVergleich = Test_Datum_12.compare( szLeer );
   if ( nVergleich != 0 )
	   InfoTXT.append ( Str_Suchen( Test_Datum_12, Read_Datei ));
   // Testen,ob Test_Datum_2 vorhanden ist
   nVergleich = Test_Datum_2.compare( szLeer );
   if ( nVergleich != 0 )
	   InfoTXT.append ( Str_Suchen( Test_Datum_2, Read_Datei ));
}

void TBirthWin::Status_Out()
{
   char Status_TXT[100] = "Zeitraum : ";
   char szAbstand[4];
   itoa( Abstand_Tage, szAbstand, 10 );
   strcat( Status_TXT, szAbstand ),
   strcat( Status_TXT, szTXT_Tage );
   TextTag -> SetText( Status_TXT );
}

int TBirthWin::TageVonMonat( int Monat, int Jahr )
{
      if ( Monat == 2 )
      {
      	TDate Heute( Date.day, Monat, Jahr );
         int Tage = TageMonat[Monat];

         if ( Heute.Leap() ) Tage += 1;
         return Tage;
      }
      else
       return TageMonat[Monat];
}

string Str_Suchen( string Suchen, string InQuelle )
{
  string Aus_Heute( "" );

   int Pos          = 0,
   	 Pos_Start    = 0,
       Pos_Ende     = 0,
       len_such_str = 0;

   len_such_str = Suchen.length();
   // string nach gleichen Datum absuchen
   while ( ( Pos != (-1) ) &&  ( Pos_Ende != ( -1 )) )
   {
   	Pos = InQuelle.find( Suchen , Pos_Start );
      // Bei bereinstimmung Eintrge sammmeln
   	if ( ( Pos != (-1) ) &&  ( Pos_Ende != ( -1 )) )
   	{
  			Pos_Ende = InQuelle.find( '\n', Pos );
         // Ergebnis testen, ob das Datum richtig gefuden wurde
         int OK = 1;
         if ( Pos != 0 )
         {
            int nASCII = InQuelle.get_at( Pos -1 );

				// Suchstring ungltig, er ist ein Teildatum
            // Wenn vor dem String eine "0" bis "9" ist , abbrechen
            if ( ( nASCII >= 48 )&& ( nASCII <= 57 ) ) OK = 0;
         	if ( InQuelle.get_at( Pos -1 ) == szPunkt[0] ) OK = 0;
            // Suchstring ungltig, wenn nach dem Datum kein
            // SPASE oder Punkt folgt ( Datum:3.12 Suchstring : 3.1 )
             nASCII = InQuelle.get_at( Pos + len_such_str  );
            if ((( nASCII == 46 ) || ( nASCII == 32 )) == 0 )	OK = 0;
        }
         if ( OK == 1 )
         {
				Aus_Heute.append( InQuelle , Pos , ( Pos_Ende - Pos ) );
         	Aus_Heute.append( cLF );
         }
      	Pos_Start = Pos_Ende;
   	}
	}
	return Aus_Heute;
}

string KopfAusgabe( int nAbstand )
{
 	string Ueberschrift ( "" );

   char szAbstand[5];
   itoa( nAbstand, szAbstand, 10 );

 	if ( nAbstand < (-1 ))
   {
      char neuAbstand[10];
   	itoa( (-1) * nAbstand, neuAbstand, 10 );
		Ueberschrift.append( "\r\nVor " );
      Ueberschrift.append( neuAbstand );
      Ueberschrift.append( " Tagen hatte Geburtstag :\r\n" );
   }
 	if ( nAbstand == (-1 ))
   	Ueberschrift.append( "\r\nVor einem Tag hatte Geburtstag : \r\n" );
 	if ( nAbstand == 0 )
   	Ueberschrift.append( "\r\nHeute hat Geburtstag : \r\n" );
 	if ( nAbstand == 1 )
   	Ueberschrift.append( "\r\nIn einem Tag hat Geburtstag : \r\n" );
 	if ( nAbstand > 1 )
   {
		Ueberschrift.append( "\r\nIn " );
      Ueberschrift.append( szAbstand );
      Ueberschrift.append( " Tagen hat Geburtstag :\r\n" );
   }
   return Ueberschrift;
}

class TBirthApp : public TApplication
{
	public:
   	TBirthApp() : TApplication() {}
      void InitMainWindow();
};

void TBirthApp::InitMainWindow()
{
	TDecoratedFrame* frame = new TDecoratedFrame( 0, "Winbirth" ,
   														 new TBirthWin, true );
  char * szTextTag = " Zeitraum : ";

  TextTag = new TTextGadget( 0, TGadget::WndRaised,
  					TTextGadget::Left, strlen( szTextTag), szTextTag );

  sb = new TStatusBar( frame, TGadget::WndRaised );
  frame -> Insert ( *sb, TDecoratedFrame::Bottom );
  sb -> Insert ( *new TSeparatorGadget( 2 ) );
  sb -> Insert ( *TextTag );

   SetMainWindow( frame );
   GetMainWindow() -> AssignMenu( IDM_MENU1 );
   GetMainWindow() -> Attr.Style = WS_MINIMIZEBOX | WS_SYSMENU ;
   GetMainWindow() -> Attr.X = xNull;
   GetMainWindow() -> Attr.Y = yNull;
   GetMainWindow() -> Attr.W = wMax;
   GetMainWindow() -> Attr.H = hMax;
}

int OwlMain( int , char*[] )
{
	return TBirthApp().Run();
}